use crate::config::DISK_IMAGE_BASE;
use fu740_hal::{clock::PrciExt, time::U32Ext};
use fu740_pac::Peripherals;
use crate::println;

pub const CLOCK_FREQ: usize = 1_000_000;

pub const MMIO: &[(usize, usize)] = &[
    (0x1000_0000, 0x1000),         // PRCI
    (DISK_IMAGE_BASE, 0x800_0000), // disk image
];

pub type BlockDeviceImpl = crate::drivers::block::MemBlockWrapper;

pub fn clock_init() {
    let prci = unsafe { Peripherals::steal().PRCI };
    let clock = prci.setup().coreclk(1_500u32.mhz()).freeze();
    println!("coreclk frequency: {:?}", clock.coreclk().0)
}
