#![allow(unused)]

pub use crate::board::{CLOCK_FREQ, MMIO};

pub const PAGE_SIZE: usize = 0x1000;
pub const PAGE_SIZE_BITS: usize = 0xc;
pub const USER_STACK_SIZE: usize = PAGE_SIZE * 5;
pub const KERNEL_STACK_SIZE: usize = PAGE_SIZE * 2;

#[cfg(feature = "board_qemu")]
pub const MEMORY_END: usize = 0x88000000;
#[cfg(feature = "board_fu740")]
pub const MEMORY_END: usize = 0x90000000;

pub const MEMORY_START2: usize = 0x9800_0000;
pub const MEMORY_END2: usize = 0x1_8000_0000;

pub const HIGH_ADDR_SPACE_BOTTOM: usize = usize::MAX - (1 << 38) + 1;
pub const TRAMPOLINE: usize = usize::MAX - PAGE_SIZE + 1;
pub const DYNAMIC_LINKER_BASE: usize = 1 << 37;
pub const TRAP_CONTEXT_TOP: usize = TRAMPOLINE;
pub const USTACK_TOP: usize = DYNAMIC_LINKER_BASE - PAGE_SIZE;
pub const MMAP_TOP: usize = 1 << 36;

pub const DISK_IMAGE_BASE: usize = 0x9000_0000;

pub const DEFAULT_FD_LIMIT: usize = 64;
pub const SYSTEM_FD_LIMIT: usize = 256;
