#![no_std]
#![no_main]

extern crate user_lib;

use user_lib::{exec, fork, mkdir, mount, println, wait, yield_, ModeFlags};

#[no_mangle]
fn main() -> i32 {
    mkdir("/proc\0", ModeFlags::DIRECTORY | ModeFlags::RWX);
    mkdir("/tmp\0", ModeFlags::DIRECTORY | ModeFlags::RW);
    mkdir("/dev\0", ModeFlags::DIRECTORY | ModeFlags::RW);
    mount("proc\0", "/proc\0", "proc\0");
    mount("udev\0", "/dev\0", "devtmpfs\0");
    if fork() == 0 {
        exec(
            "user_shell\0",
            &[core::ptr::null::<u8>()],
            &[core::ptr::null::<u8>()],
        );
    } else {
        loop {
            let mut exit_code: i32 = 0;
            let pid = wait(&mut exit_code);
            if pid == -1 {
                yield_();
                continue;
            }
            /*
            println!(
                "[initproc] Released a zombie process, pid={}, exit_code={}",
                pid,
                exit_code,
            );
            */
        }
    }
    0
}
