use super::{read, write};

const STDIN: usize = 0;
const STDOUT: usize = 1;

pub fn print(args: &str) {
    assert_eq!(write(STDOUT, args.as_bytes()), args.len() as isize)
}

#[macro_export]
macro_rules! print {
    ($fmt: literal $(, $($arg: tt)+)?) => {
        $crate::console::print(&alloc::format!($fmt $(, $($arg)+)?));
    }
}

#[macro_export]
macro_rules! println {
    ($fmt: literal $(, $($arg: tt)+)?) => {
        $crate::console::print(&alloc::format!(concat!($fmt, "\n") $(, $($arg)+)?));
    }
}

pub fn getchar() -> u8 {
    let mut c = [0u8; 1];
    read(STDIN, &mut c);
    c[0]
}
